# Class LayerDialog

界面层对象

#### Hierarchy

- LayerPopUp
  - LayerDialog

- Defined in assets/core/gui/layer/LayerDialog.ts:23

#####
Index

### Constructors

constructor

### Properties

__editorExtras__
_active
_activeInHierarchy
_children
_components
_euler
_eulerDirty
_eventMask
_eventProcessor
_flagChangeVersion
_hasChangedFlags
_id
_layer
_lpos
_lrot
_lscale
_mobility
_name
_objFlags
_originalSceneId
_parent
_prefab
_scene
_siblingIndex
_static
_transformFlags
_uiProps
black
mask
params
ui_cache
ui_nodes
EventType
NodeSpace
TransformBit
TransformDirtyBit
_stackId
_stacks
idGenerator
reserveContentsForAllSyncablePrefabTag

### Accessors

_persistNode
active
activeInHierarchy
angle
children
components
eulerAngles
eventProcessor
forward
hasChangedFlags
hideFlags
isValid
layer
matrix
mobility
name
parent
position
right
rotation
scale
scene
up
uuid
worldMatrix
worldPosition
worldRotation
worldScale

### Methods

[serializeTag]
_checkMultipleComp?
_destroyImmediate
_destruct
_instantiate
_onBatchCreated
_onBeforeSerialize
_onHierarchyChanged
_onHierarchyChangedBase
_onPostActivated
_onPreDestroy
_onPreDestroyBase
_onSetParent
_onSiblingIndexChanged?
_removeComponent
_updateScene
_updateSiblingIndex
add
addChild
addComponent
attr
clear
closeMask
closeVacancyRemove
destroy
destroyAllChildren
dispatchEvent
emit
get
getChildByName
getChildByPath
getChildByUuid
getComponent
getComponentInChildren
getComponents
getComponentsInChildren
getParent
getPathInHierarchy
getPosition
getRotation
getScale
getSiblingIndex
getWorldMatrix
getWorldPosition
getWorldRS
getWorldRT
getWorldRotation
getWorldScale
has
hasEventListener
insertChild
invalidateChildren
inverseTransformPoint
isChildOf
isTransformDirty
load
lookAt
next
off
on
onHide
once
openVacancyRemove
pauseSystemEvents
remove
removeAllChildren
removeChild
removeComponent
removeFromParent
resumeSystemEvents
rotate
setBlackDisable
setParent
setPosition
setRTS
setRotation
setRotationFromEuler
setScale
setSiblingIndex
setWorldPosition
setWorldRotation
setWorldRotationFromEuler
setWorldScale
show
showUi
targetOff
translate
updateWorldTransform
walk
_deferredDestroy
_findChildComponent
_findChildComponents
_findComponent
_findComponents
_setScene
clearNodeArray
isNode
resetHasChangedFlags

## Constructors

### constructor

- new LayerDialog(name: string): LayerDialog

- #### Parameters

  - ##### name: string

  #### Returns LayerDialog

  Inherited from LayerPopUp.constructor

  - Defined in assets/core/gui/layer/LayerPopup.ts:22

## Properties

### `Internal` __editorExtras__

__editorExtras__: unknown

Inherited from LayerPopUp.__editorExtras__

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20877

### `Protected` _active

_active: boolean

Inherited from LayerPopUp._active

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24190

### `Protected` _activeInHierarchy

_activeInHierarchy: boolean

Inherited from LayerPopUp._activeInHierarchy

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24198

### `Protected` _children

_children: LayerDialog []

Inherited from LayerPopUp._children

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24189

### `Protected` _components

_components: Component[]

Inherited from LayerPopUp._components

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24191

### `Protected` _euler

_euler: Vec3

Inherited from LayerPopUp._euler

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24667

### `Protected` _eulerDirty

_eulerDirty: boolean

Inherited from LayerPopUp._eulerDirty

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24669

### `Protected` _eventMask

_eventMask: number

Inherited from LayerPopUp._eventMask

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24202

### `Protected` _eventProcessor

_eventProcessor: _cocos_scene_graph_node_event_processor__NodeEventProcessor

Inherited from LayerPopUp._eventProcessor

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24201

### `Protected` _flagChangeVersion

_flagChangeVersion: number

Inherited from LayerPopUp._flagChangeVersion

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24670

### `Protected` _hasChangedFlags

_hasChangedFlags: number

Inherited from LayerPopUp._hasChangedFlags

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24671

### `Protected` _id

_id: string

Inherited from LayerPopUp._id

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24199

### `Protected` _layer

_layer: number

Inherited from LayerPopUp._layer

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24666

### `Protected` _lpos

_lpos: Vec3

Inherited from LayerPopUp._lpos

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24662

### `Protected` _lrot

_lrot: Quat

Inherited from LayerPopUp._lrot

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24663

### `Protected` _lscale

_lscale: Vec3

Inherited from LayerPopUp._lscale

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24664

### `Protected` _mobility

_mobility: number

Inherited from LayerPopUp._mobility

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24665

### `Protected` _name

_name: string

Inherited from LayerPopUp._name

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24200

### `Internal` _objFlags

_objFlags: number

Inherited from LayerPopUp._objFlags

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20881

### _originalSceneId

_originalSceneId: string

### En

record scene's id when set this node as persist node

### Zh

当设置节点为常驻节点时记录场景的 id

### Deprecated

since v3.5.0, this is an engine private interface that will be removed in the future.

Inherited from LayerPopUp._originalSceneId

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24211

### `Protected` _parent

_parent: null | LayerDialog

Inherited from LayerPopUp._parent

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24188

### `Protected` _prefab

_prefab: null | PrefabInfo

TODO(PP_Pro): this property should be exported to editor only, we should support editorOnly tag. Tracking issue: https://github.com/cocos/cocos-engine/issues/14613

Inherited from LayerPopUp._prefab

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24196

### `Protected` _scene

_scene: Scene

Inherited from LayerPopUp._scene

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24197

### `Protected` _siblingIndex

_siblingIndex: number

Inherited from LayerPopUp._siblingIndex

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24203

### _static

_static: boolean

### Deprecated

since v3.5.0, this is an engine private interface that will be removed in the future.

Inherited from LayerPopUp._static

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24661

### `Protected` _transformFlags

_transformFlags: TransformBit

Inherited from LayerPopUp._transformFlags

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24668

### _uiProps

_uiProps: _cocos_scene_graph_node_ui_properties__NodeUIProperties

### Deprecated

since v3.5.0, this is an engine private interface that will be removed in the future.

Inherited from LayerPopUp._uiProps

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24657

### `Protected` black

black: BlockInputEvents

触摸事件阻挡

Inherited from LayerPopUp.black

- Defined in assets/core/gui/layer/LayerPopup.ts:18

### `Protected` mask

mask: Node

半透明遮罩资源

Inherited from LayerPopUp.mask

- Defined in assets/core/gui/layer/LayerPopup.ts:20

### `Private` params

params: DialogParam[] = []

窗口调用参数队列

- Defined in assets/core/gui/layer/LayerDialog.ts:25

### `Protected` ui_cache

ui_cache: Map<string, ViewParams > = ...

被移除的界面缓存数据

Inherited from LayerPopUp.ui_cache

- Defined in assets/core/gui/layer/LayerUI.ts:12

### `Protected` ui_nodes

ui_nodes: Map<string, ViewParams > = ...

显示界面节点集合

Inherited from LayerPopUp.ui_nodes

- Defined in assets/core/gui/layer/LayerUI.ts:10

### `Static` EventType

EventType: typeof NodeEventType

### En

Event types emitted by Node

### Zh

节点可能发出的事件类型

Inherited from LayerPopUp.EventType

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24633

### `Static` NodeSpace

NodeSpace: typeof NodeSpace

### En

Coordinates space

### Zh

空间变换操作的坐标系

Inherited from LayerPopUp.NodeSpace

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24638

### `Static` TransformBit

TransformBit: typeof TransformBit

### En

Bit masks for Node transformation parts, can be used to determine which part changed in NodeEventType.TRANSFORM_CHANGED event

### Zh

节点变换更新的具体部分，可用于判断 NodeEventType.TRANSFORM_CHANGED 事件的具体类型

Inherited from LayerPopUp.TransformBit

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24649

### `Static` TransformDirtyBit

TransformDirtyBit: typeof TransformBit

### En

Bit masks for Node transformation parts

### Zh

节点变换更新的具体部分

### Deprecated

please use Node.TransformBit

Inherited from LayerPopUp.TransformDirtyBit

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24644

### `Static` `Protected` `Internal` _stackId

_stackId: number

Inherited from LayerPopUp._stackId

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24177

### `Static` `Protected` `Internal` _stacks

_stacks: (null | Node)[][]

for walk

Inherited from LayerPopUp._stacks

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24173

### `Static` `Protected` `Internal` idGenerator

idGenerator: IDGenerator

Inherited from LayerPopUp.idGenerator

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24168

### `Static` reserveContentsForAllSyncablePrefabTag

reserveContentsForAllSyncablePrefabTag: symbol

### Deprecated

since v3.5.0, this is an engine private interface that will be removed in the future.

Inherited from LayerPopUp.reserveContentsForAllSyncablePrefabTag

- Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24653

## Accessors

### _persistNode

- get _persistNode(): boolean

- ### En

  If true, the node is an persist node which won't be destroyed during scene transition. If false, the node will be destroyed automatically when loading a new scene. Default is false.

  ### Zh

  如果为true，则该节点是一个常驻节点，不会在场景转换期间被销毁。 如果为false，节点将在加载新场景时自动销毁。默认为 false。

  ### Default

  false

  ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Returns boolean

  Inherited from LayerPopUp._persistNode

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24106
- set _persistNode(value: boolean): void

- #### Parameters

  - ##### value: boolean

  #### Returns void

  Inherited from LayerPopUp._persistNode

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24107

### active

- get active(): boolean

- ### En

  The local active state of this node. Note that a Node may be inactive because a parent is not active, even if this returns true. Use activeInHierarchy if you want to check if the Node is actually treated as active in the scene.

  ### Zh

  当前节点的自身激活状态。 值得注意的是，一个节点的父节点如果不被激活，那么即使它自身设为激活，它仍然无法激活。 如果你想检查节点在场景中实际的激活状态可以使用 activeInHierarchy

  ### Default

  true

  #### Returns boolean

  Inherited from LayerPopUp.active

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24138
- set active(isActive: boolean): void

- #### Parameters

  - ##### isActive: boolean

  #### Returns void

  Inherited from LayerPopUp.active

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24139

### activeInHierarchy

- get activeInHierarchy(): boolean

- ### En

  Indicates whether this node is active in the scene.

  ### Zh

  表示此节点是否在场景中激活。

  #### Returns boolean

  Inherited from LayerPopUp.activeInHierarchy

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24144

### angle

- get angle(): number

- ### En

  Rotation in local coordinate system, represented by euler angles, but limited on z axis

  ### Zh

  本地坐标系下的旋转，用欧拉角表示，但是限定在 z 轴上。

  #### Returns number

  Inherited from LayerPopUp.angle

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24707
- set angle(val: number): void

- #### Parameters

  - ##### val: number

  #### Returns void

  Inherited from LayerPopUp.angle

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24708

### children

- get children(): Node[]

- ### En

  All children nodes.

  ### Zh

  节点的所有子节点。

  ### Read Only

  #### Returns Node[]

  Inherited from LayerPopUp.children

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24125

### components

- get components(): readonly Component[]

- ### En

  Gets all components attached to this node.

  ### Zh

  获取附加到此节点的所有组件。

  #### Returns readonly Component[]

  Inherited from LayerPopUp.components

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24097

### eulerAngles

- get eulerAngles(): Readonly<Vec3>

- #### Returns Readonly<Vec3>

  Inherited from LayerPopUp.eulerAngles

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24702
- set eulerAngles(val: Readonly<Vec3>): void

- ### En

  Rotation in local coordinate system, represented by euler angles

  ### Zh

  本地坐标系下的旋转，用欧拉角表示

  #### Parameters

  - ##### val: Readonly<Vec3>

  #### Returns void

  Inherited from LayerPopUp.eulerAngles

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24701

### eventProcessor

- get eventProcessor(): _cocos_scene_graph_node_event_processor__NodeEventProcessor

- ### En

  The event processor of the current node, it provides EventTarget ability.

  ### Zh

  当前节点的事件处理器，提供 EventTarget 能力。

  ### Deprecated

  since v3.4.0

  #### Returns _cocos_scene_graph_node_event_processor__NodeEventProcessor

  Inherited from LayerPopUp.eventProcessor

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24164

### forward

- get forward(): Vec3

- ### En

  The vector representing forward direction in local coordinate system, it's the minus z direction by default

  ### Zh

  当前节点面向的前方方向，默认前方为 -z 方向

  #### Returns Vec3

  Inherited from LayerPopUp.forward

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24741
- set forward(dir: Vec3): void

- #### Parameters

  - ##### dir: Vec3

  #### Returns void

  Inherited from LayerPopUp.forward

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24742

### hasChangedFlags

- get hasChangedFlags(): number

- ### En

  Whether the node's transformation have changed during the current frame.

  ### Zh

  这个节点的空间变换信息在当前帧内是否有变过？

  #### Returns number

  Inherited from LayerPopUp.hasChangedFlags

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24765
- set hasChangedFlags(val: number): void

- #### Parameters

  - ##### val: number

  #### Returns void

  Inherited from LayerPopUp.hasChangedFlags

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24766

### hideFlags

- get hideFlags(): Flags

- #### Returns Flags

  Inherited from LayerPopUp.hideFlags

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20900
- set hideFlags(hideFlags: Flags): void

- ### En

  After inheriting CCObject objects, control whether you need to hide, lock, serialize, and other functions.

  ### Zh

  在继承 CCObject 对象后，控制是否需要隐藏，锁定，序列化等功能。

  #### Parameters

  - ##### hideFlags: Flags

  #### Returns void

  Inherited from LayerPopUp.hideFlags

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20899

### isValid

- get isValid(): boolean

- ### En

  Indicates whether the object is not yet destroyed. (It will not be available after being destroyed)
  When an object's `destroy` is called, it is actually destroyed after the end of this frame. So `isValid` will return false from the next frame, while `isValid` in the current frame will still be true. If you want to determine whether the current frame has called `destroy`, use `isValid(obj, true)`, but this is often caused by a particular logical requirements, which is not normally required.

  ### Zh

  表示该对象是否可用（被 destroy 后将不可用）。
  当一个对象的 `destroy` 调用以后，会在这一帧结束后才真正销毁。
  因此从下一帧开始 `isValid` 就会返回 false，而当前帧内 `isValid` 仍然会是 true。
  如果希望判断当前帧是否调用过 `destroy`，请使用 `isValid(obj, true)`，不过这往往是特殊的业务需求引起的，通常情况下不需要这样。

  ### Default

  true

  ### Read Only

  ### Example

      import { Node, log } from 'cc';
      const node = new Node();
      log(node.isValid);    // true
      node.destroy();
      log(node.isValid);    // true, still valid in this frame
      // after a frame...
      log(node.isValid);    // false, destroyed in the end of last frame

  #### Returns boolean

  Inherited from LayerPopUp.isValid

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20927

### layer

- get layer(): number

- #### Returns number

  Inherited from LayerPopUp.layer

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24760
- set layer(l: number): void

- ### En

  Layer of the current Node, it affects raycast, physics etc, refer to Layers

  ### Zh

  节点所属层，主要影响射线检测、物理碰撞等，参考 Layers

  #### Parameters

  - ##### l: number

  #### Returns void

  Inherited from LayerPopUp.layer

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24759

### matrix

- set matrix(val: Readonly<Mat4>): void

- ### En

  Local transformation matrix

  ### Zh

  本地坐标系变换矩阵

  #### Parameters

  - ##### val: Readonly<Mat4>

  #### Returns void

  Inherited from LayerPopUp.matrix

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24731

### mobility

- get mobility(): number

- #### Returns number

  Inherited from LayerPopUp.mobility

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24754
- set mobility(m: number): void

- #### Parameters

  - ##### m: number

  #### Returns void

  Inherited from LayerPopUp.mobility

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24753

### name

- get name(): string

- ### En

  Name of node.

  ### Zh

  该节点名称。

  #### Returns string

  Inherited from LayerPopUp.name

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24112
- set name(value: string): void

- #### Parameters

  - ##### value: string

  #### Returns void

  Inherited from LayerPopUp.name

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24113

### parent

- get parent(): null | Node

- ### En

  The parent node

  ### Zh

  父节点

  #### Returns null | Node

  Inherited from LayerPopUp.parent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24149
- set parent(value: null | Node): void

- #### Parameters

  - ##### value: null | Node

  #### Returns void

  Inherited from LayerPopUp.parent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24150

### position

- get position(): Readonly<Vec3>

- ### En

  Position in local coordinate system

  ### Zh

  本地坐标系下的坐标

  #### Returns Readonly<Vec3>

  Inherited from LayerPopUp.position

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24683
- set position(val: Readonly<Vec3>): void

- #### Parameters

  - ##### val: Readonly<Vec3>

  #### Returns void

  Inherited from LayerPopUp.position

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24684

### right

- get right(): Vec3

- ### En

  Return the right direction vector of this node in world space.

  ### Zh

  返回当前节点在世界空间中朝右的方向向量

  #### Returns Vec3

  Inherited from LayerPopUp.right

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24752

### rotation

- get rotation(): Readonly<Quat>

- ### En

  Rotation in local coordinate system, represented by a quaternion

  ### Zh

  本地坐标系下的旋转，用四元数表示

  #### Returns Readonly<Quat>

  Inherited from LayerPopUp.rotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24695
- set rotation(val: Readonly<Quat>): void

- #### Parameters

  - ##### val: Readonly<Quat>

  #### Returns void

  Inherited from LayerPopUp.rotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24696

### scale

- get scale(): Readonly<Vec3>

- ### En

  Scale in local coordinate system

  ### Zh

  本地坐标系下的缩放

  #### Returns Readonly<Vec3>

  Inherited from LayerPopUp.scale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24719
- set scale(val: Readonly<Vec3>): void

- #### Parameters

  - ##### val: Readonly<Vec3>

  #### Returns void

  Inherited from LayerPopUp.scale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24720

### scene

- get scene(): Scene

- ### En

  Which scene this node belongs to.

  ### Zh

  此节点属于哪个场景。

  #### Returns Scene

  Inherited from LayerPopUp.scene

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24156

### up

- get up(): Vec3

- ### En

  Return the up direction vertor of this node in world space.

  ### Zh

  返回当前节点在世界空间中朝上的方向向量

  #### Returns Vec3

  Inherited from LayerPopUp.up

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24747

### uuid

- get uuid(): string

- ### En

  The uuid for editor, will be stripped after building project.

  ### Zh

  主要用于编辑器的 uuid，在编辑器下可用于持久化存储，在项目构建之后将变成自增的 id。

  ### Read Only

  #### Returns string

  Inherited from LayerPopUp.uuid

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24119

### worldMatrix

- get worldMatrix(): Readonly<Mat4>

- ### En

  World transformation matrix

  ### Zh

  世界坐标系变换矩阵

  #### Returns Readonly<Mat4>

  Inherited from LayerPopUp.worldMatrix

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24736

### worldPosition

- get worldPosition(): Readonly<Vec3>

- ### En

  Position in world coordinate system

  ### Zh

  世界坐标系下的坐标

  #### Returns Readonly<Vec3>

  Inherited from LayerPopUp.worldPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24689
- set worldPosition(val: Readonly<Vec3>): void

- #### Parameters

  - ##### val: Readonly<Vec3>

  #### Returns void

  Inherited from LayerPopUp.worldPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24690

### worldRotation

- get worldRotation(): Readonly<Quat>

- ### En

  Rotation in world coordinate system, represented by a quaternion

  ### Zh

  世界坐标系下的旋转，用四元数表示

  #### Returns Readonly<Quat>

  Inherited from LayerPopUp.worldRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24713
- set worldRotation(val: Readonly<Quat>): void

- #### Parameters

  - ##### val: Readonly<Quat>

  #### Returns void

  Inherited from LayerPopUp.worldRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24714

### worldScale

- get worldScale(): Readonly<Vec3>

- ### En

  Scale in world coordinate system

  ### Zh

  世界坐标系下的缩放

  #### Returns Readonly<Vec3>

  Inherited from LayerPopUp.worldScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24725
- set worldScale(val: Readonly<Vec3>): void

- #### Parameters

  - ##### val: Readonly<Vec3>

  #### Returns void

  Inherited from LayerPopUp.worldScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24726

## Methods

### [serializeTag]

- [serializeTag](serializationOutput: SerializationOutput, context: SerializationContext): void
- `Internal`

  #### Parameters

  - ##### serializationOutput: SerializationOutput

  - ##### context: SerializationContext

  #### Returns void

  Inherited from LayerPopUp.[serializeTag]

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24770

### `Protected` `Optional` _checkMultipleComp

- _checkMultipleComp<T>(constructor: __types_globals__Constructor<T>): void

- ### En

  Ensures that this node has already had the specified component(s). If not, this method throws.

  ### Zh

  检查节点已经包含对应的组件，如果没有，则抛出异常

  ### Throws

  If one or more component of same type have been existed in this node.

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### constructor: __types_globals__Constructor<T>

    Constructor of the component.

  #### Returns void

  Inherited from LayerPopUp._checkMultipleComp

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24628

### _destroyImmediate

- _destroyImmediate(): void

- ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Returns void

  Inherited from LayerPopUp._destroyImmediate

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20978

### _destruct

- _destruct(): void

- ### En

  Clear all references in the instance.

  NOTE: this method will not clear the getter or setter functions which defined in the instance of CCObject.

  ### Zh

  清理实例的所有引用 注意：此方法不会清理实例上的 getter 与 setter 方法。

  ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  ### Example

      // You can override the _destruct method if you need, for example:
            _destruct: function () {
                for (var key in this) {
                    if (this.hasOwnProperty(key)) {
                        switch (typeof this[key]) {
                            case 'string':
                                this[key] = '';
                                break;
                            case 'object':
                            case 'function':
                                this[key] = null;
                                break;
                    }
                }
            }

  #### Returns void

  Inherited from LayerPopUp._destruct

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20974

### `Protected` _instantiate

- _instantiate(cloned: any, isSyncedNode: any): any

- #### Parameters

  - ##### cloned: any

  - ##### isSyncedNode: any

  #### Returns any

  Inherited from LayerPopUp._instantiate

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24616

### _onBatchCreated

- _onBatchCreated(dontSyncChildPrefab: boolean): void

- ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Parameters

  - ##### dontSyncChildPrefab: boolean

  #### Returns void

  Inherited from LayerPopUp._onBatchCreated

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24779

### _onBeforeSerialize

- _onBeforeSerialize(): void

- ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Returns void

  Inherited from LayerPopUp._onBeforeSerialize

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24783

### `Protected` _onHierarchyChanged

- _onHierarchyChanged(oldParent: null | LayerDialog ): void

- #### Parameters

  - ##### oldParent: null | LayerDialog

  #### Returns void

  Inherited from LayerPopUp._onHierarchyChanged

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24775

### `Protected` _onHierarchyChangedBase

- _onHierarchyChangedBase(oldParent: null | LayerDialog ): void

- #### Parameters

  - ##### oldParent: null | LayerDialog

  #### Returns void

  Inherited from LayerPopUp._onHierarchyChangedBase

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24617

### _onPostActivated

- _onPostActivated(active: boolean): void

- ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Parameters

  - ##### active: boolean

  #### Returns void

  Inherited from LayerPopUp._onPostActivated

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24787

### `Protected` _onPreDestroy

- _onPreDestroy(): boolean

- #### Returns boolean

  Inherited from LayerPopUp._onPreDestroy

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24678

### `Protected` _onPreDestroyBase

- _onPreDestroyBase(): boolean

- #### Returns boolean

  Inherited from LayerPopUp._onPreDestroyBase

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24618

### _onSetParent

- _onSetParent(oldParent: null | LayerDialog, keepWorldTransform?: boolean): void

- ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Parameters

  - ##### oldParent: null | LayerDialog

  - ##### `Optional` keepWorldTransform: boolean

  #### Returns void

  Inherited from LayerPopUp._onSetParent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24774

### `Protected` `Optional` _onSiblingIndexChanged

- _onSiblingIndexChanged(siblingIndex: number): void

- #### Parameters

  - ##### siblingIndex: number

  #### Returns void

  Inherited from LayerPopUp._onSiblingIndexChanged

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24619

### _removeComponent

- _removeComponent(component: Component): void

- Do remove component, only used internally.

  ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Parameters

  - ##### component: Component

  #### Returns void

  Inherited from LayerPopUp._removeComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24611

### `Protected` _updateScene

- _updateScene(): void

- Set `_scene` field of this node. The derived `Scene` overrides this method to behavior differently.

  ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Returns void

  Inherited from LayerPopUp._updateScene

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24217

### _updateSiblingIndex

- _updateSiblingIndex(): void

- ### Deprecated

  since v3.5.0, this is an engine private interface that will be removed in the future.

  #### Returns void

  Inherited from LayerPopUp._updateSiblingIndex

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24615

### add

- add(config: UIConfig, params?: any, callbacks?: UICallbacks ): void

- 添加一个预制件节点到层容器中，该方法将返回一个唯一`uuid`来标识该操作节点

  ### Returns

  ture为成功,false为失败

  #### Parameters

  - ##### config: UIConfig

  - ##### `Optional` params: any

    自定义参数

  - ##### `Optional` callbacks: UICallbacks

    回调函数对象，可选

  #### Returns void

  Overrides LayerPopUp.add

  - Defined in assets/core/gui/layer/LayerDialog.ts:27

### addChild

- addChild(child: Node): void

- ### En

  Add a child to the current node.

  ### Zh

  添加一个子节点。

  #### Parameters

  - ##### child: Node

    the child node to be added

  #### Returns void

  Inherited from LayerPopUp.addChild

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24279

### addComponent

- addComponent<T>(classConstructor: __types_globals__Constructor<T>): T

- ### En

  Adds a component class to the node. You can also add component to node by passing in the name of the script.

  ### Zh

  向节点添加一个指定类型的组件类，你还可以通过传入脚本的名称来添加组件。

  ### Throws

  `TypeError` if the `classConstructor` does not specify a cc-class constructor extending the `Component`.

  ### Example

      var sprite = node.addComponent(Sprite);

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### classConstructor: __types_globals__Constructor<T>

    The class of the component to add

  #### Returns T

  Inherited from LayerPopUp.addComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24441
- addComponent(className: string): Component

- ### En

  Adds a component class to the node. You can also add component to node by passing in the name of the script.

  ### Zh

  向节点添加一个指定类型的组件类，你还可以通过传入脚本的名称来添加组件。

  ### Throws

  `TypeError` if the `className` does not specify a cc-class constructor extending the `Component`.

  ### Example

      var test = node.addComponent("Test");

  #### Parameters

  - ##### className: string

    The class name of the component to add

  #### Returns Component

  Inherited from LayerPopUp.addComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24452

### attr

- attr(attrs: unknown): void

- ### En

  Properties configuration function. All properties in attrs will be set to the node, when the setter of the node is available, the property will be set via setter function.

  ### Zh

  属性配置函数。在 attrs 的所有属性将被设置为节点属性。

  ### Example

      var attrs = { name: 'New Name', active: false };
      node.attr(attrs);

  #### Parameters

  - ##### attrs: unknown

    Properties to be set to node

  #### Returns void

  Inherited from LayerPopUp.attr

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24232

### clear

- clear(isDestroy: boolean): void

- 清除所有节点，队列当中的也删除

  #### Parameters

  - ##### isDestroy: boolean

    移除后是否释放

  #### Returns void

  Inherited from LayerPopUp.clear

  - Defined in assets/core/gui/layer/LayerPopup.ts:117

### `Protected` closeMask

- closeMask(): void

- 关闭遮罩

  #### Returns void

  Inherited from LayerPopUp.closeMask

  - Defined in assets/core/gui/layer/LayerPopup.ts:61

### `Protected` closeVacancyRemove

- closeVacancyRemove(): void

- 关闭触摸非窗口区域关闭

  #### Returns void

  Inherited from LayerPopUp.closeVacancyRemove

  - Defined in assets/core/gui/layer/LayerPopup.ts:92

### destroy

- destroy(): boolean

- #### Returns boolean

  Inherited from LayerPopUp.destroy

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24597

### destroyAllChildren

- destroyAllChildren(): void

- ### En

  Destroy all children from the node, and release all their own references to other objects. Actual destruct operation will delayed until before rendering.

  ### Zh

  销毁所有子节点，并释放所有它们对其它对象的引用。 实际销毁操作会延迟到当前帧渲染前执行。

  #### Returns void

  Inherited from LayerPopUp.destroyAllChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24606

### dispatchEvent

- dispatchEvent(event: Event): void

- ### En

  Dispatches an event into the event flow. The event target is the EventTarget object upon which the dispatchEvent() method is called.

  ### Zh

  分发事件到事件流中。

  #### Parameters

  - ##### event: Event

    The Event object that is dispatched into the event flow

  #### Returns void

  Inherited from LayerPopUp.dispatchEvent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24581

### emit

- emit(type: string, arg0?: any, arg1?: any, arg2?: any, arg3?: any, arg4?: any): void

- ### En

  Trigger an event directly with the event name and necessary arguments.

  ### Zh

  通过事件名发送自定义事件

  ### Example

      eventTarget.emit('fire', event);
      eventTarget.emit('fire', message, emitter);

  #### Parameters

  - ##### type: string

    event type

  - ##### `Optional` arg0: any

  - ##### `Optional` arg1: any

    First argument in callback

  - ##### `Optional` arg2: any

    Second argument in callback

  - ##### `Optional` arg3: any

    Third argument in callback

  - ##### `Optional` arg4: any

    Fourth argument in callback

  #### Returns void

  Inherited from LayerPopUp.emit

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24573

### get

- get(prefabPath: string): Node

- 根据预制路径获取已打开界面的节点对象

  #### Parameters

  - ##### prefabPath: string

    预制路径

  #### Returns Node

  Inherited from LayerPopUp.get

  - Defined in assets/core/gui/layer/LayerUI.ts:162

### getChildByName

- getChildByName(name: string): null | Node

- ### En

  Returns a child with the same name.

  ### Zh

  通过名称获取节点的子节点。

  ### Returns

  a CCNode object whose name equals to the input parameter

  ### Example

      var child = node.getChildByName("Test Node");

  #### Parameters

  - ##### name: string

    A name to find the child node.

  #### Returns null | Node

  Inherited from LayerPopUp.getChildByName

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24262

### getChildByPath

- getChildByPath(path: string): null | Node

- ### En

  Returns a child with the given path.

  ### Zh

  通过路径获取节点的子节点。

  ### Returns

  a Node object whose path equals to the input parameter

  ### Example

      var child = node.getChildByPath("subNode/Test Node");

  #### Parameters

  - ##### path: string

    A path to find the child node.

  #### Returns null | Node

  Inherited from LayerPopUp.getChildByPath

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24273

### getChildByUuid

- getChildByUuid(uuid: string): null | Node

- ### En

  Returns a child with the same uuid.

  ### Zh

  通过 uuid 获取节点的子节点。

  ### Returns

  a Node whose uuid equals to the input parameter

  #### Parameters

  - ##### uuid: string

    The uuid to find the child node.

  #### Returns null | Node

  Inherited from LayerPopUp.getChildByUuid

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24251

### getComponent

- getComponent<T>(classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): null | T

- ### En

  Returns the component of supplied type if the node has one attached, null if it doesn't. You can also get component in the node by passing in the name of the script.

  ### Zh

  获取节点上指定类型的组件，如果节点有附加指定类型的组件，则返回，如果没有则为空。 传入参数也可以是脚本的名称。

  ### Example

      // get sprite component.
      var sprite = node.getComponent(Sprite);

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

    The class of the target component

  #### Returns null | T

  Inherited from LayerPopUp.getComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24363
- getComponent(className: string): null | Component

- ### En

  Returns the component of supplied type if the node has one attached, null if it doesn't. You can also get component in the node by passing in the name of the script.

  ### Zh

  获取节点上指定类型的组件，如果节点有附加指定类型的组件，则返回，如果没有则为空。 传入参数也可以是脚本的名称。

  ### Example

      // get custom test class.
      var test = node.getComponent("Test");

  #### Parameters

  - ##### className: string

    The class name of the target component

  #### Returns null | Component

  Inherited from LayerPopUp.getComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24378

### getComponentInChildren

- getComponentInChildren<T>(classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): null | T

- ### En

  Returns the component of given type in any of its children using depth first search.

  ### Zh

  递归查找所有子节点中第一个匹配指定类型的组件。

  ### Example

      var sprite = node.getComponentInChildren(Sprite);

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

    The class of the target component

  #### Returns null | T

  Inherited from LayerPopUp.getComponentInChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24400
- getComponentInChildren(className: string): null | Component

- ### En

  Returns the component of given type in any of its children using depth first search.

  ### Zh

  递归查找所有子节点中第一个匹配指定类型的组件。

  ### Example

      var Test = node.getComponentInChildren("Test");

  #### Parameters

  - ##### className: string

    The class name of the target component

  #### Returns null | Component

  Inherited from LayerPopUp.getComponentInChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24410

### getComponents

- getComponents<T>(classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): T[]

- ### En

  Returns all components of given type in the node.

  ### Zh

  返回节点上指定类型的所有组件。

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

    The class of the target component

  #### Returns T[]

  Inherited from LayerPopUp.getComponents

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24384
- getComponents(className: string): Component[]

- ### En

  Returns all components of given type in the node.

  ### Zh

  返回节点上指定类型的所有组件。

  #### Parameters

  - ##### className: string

    The class name of the target component

  #### Returns Component[]

  Inherited from LayerPopUp.getComponents

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24390

### getComponentsInChildren

- getComponentsInChildren<T>(classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): T[]

- ### En

  Returns all components of given type in self or any of its children.

  ### Zh

  递归查找自身或所有子节点中指定类型的组件

  ### Example

      var sprites = node.getComponentsInChildren(Sprite);

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

    The class of the target component

  #### Returns T[]

  Inherited from LayerPopUp.getComponentsInChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24420
- getComponentsInChildren(className: string): Component[]

- ### En

  Returns all components of given type in self or any of its children.

  ### Zh

  递归查找自身或所有子节点中指定类型的组件

  ### Example

      var tests = node.getComponentsInChildren("Test");

  #### Parameters

  - ##### className: string

    The class name of the target component

  #### Returns Component[]

  Inherited from LayerPopUp.getComponentsInChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24430

### getParent

- getParent(): null | Node

- ### En

  Get parent of the node.

  ### Zh

  获取该节点的父节点。

  #### Returns null | Node

  Inherited from LayerPopUp.getParent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24237

### getPathInHierarchy

- getPathInHierarchy(): string

- ### En

  Get the complete path of the current node in the hierarchy.

  ### Zh

  获得当前节点在 hierarchy 中的完整路径。

  #### Returns string

  Inherited from LayerPopUp.getPathInHierarchy

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25058

### getPosition

- getPosition(out?: Vec3): Vec3

- ### En

  Get position in local coordinate system, please try to pass `out` vector and reuse it to avoid garbage.

  ### Zh

  获取本地坐标，注意，尽可能传递复用的 Vec3 以避免产生垃圾。

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new vector will be generated and return

  #### Parameters

  - ##### `Optional` out: Vec3

    Set the result to out vector

  #### Returns Vec3

  Inherited from LayerPopUp.getPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24841

### getRotation

- getRotation(out?: Quat): Quat

- ### En

  Get rotation as quaternion in local coordinate system, please try to pass `out` quaternion and reuse it to avoid garbage.

  ### Zh

  获取本地旋转，注意，尽可能传递复用的 Quat 以避免产生垃圾。

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new quaternion will be generated and return

  #### Parameters

  - ##### `Optional` out: Quat

    Set the result to out quaternion

  #### Returns Quat

  Inherited from LayerPopUp.getRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24879

### getScale

- getScale(out?: Vec3): Vec3

- ### En

  Get scale in local coordinate system, please try to pass `out` vector and reuse it to avoid garbage.

  ### Zh

  获取本地缩放，注意，尽可能传递复用的 Vec3 以避免产生垃圾。

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new vector will be generated and return

  #### Parameters

  - ##### `Optional` out: Vec3

    Set the result to out vector

  #### Returns Vec3

  Inherited from LayerPopUp.getScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24900

### getSiblingIndex

- getSiblingIndex(): number

- ### En

  Get the sibling index of the current node in its parent's children array.

  ### Zh

  获取当前节点在父节点的 children 数组中的位置。

  #### Returns number

  Inherited from LayerPopUp.getSiblingIndex

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24295

### getWorldMatrix

- getWorldMatrix(out?: Mat4): Mat4

- ### En

  Get a world transform matrix

  ### Zh

  获取世界变换矩阵

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new matrix will be generated and return

  #### Parameters

  - ##### `Optional` out: Mat4

    Set the result to out matrix

  #### Returns Mat4

  Inherited from LayerPopUp.getWorldMatrix

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24986

### getWorldPosition

- getWorldPosition(out?: Vec3): Vec3

- ### En

  Get position in world coordinate system, please try to pass `out` vector and reuse it to avoid garbage.

  ### Zh

  获取世界坐标，注意，尽可能传递复用的 Vec3 以避免产生垃圾。

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new vector will be generated and return

  #### Parameters

  - ##### `Optional` out: Vec3

    Set the result to out vector

  #### Returns Vec3

  Inherited from LayerPopUp.getWorldPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24928

### getWorldRS

- getWorldRS(out?: Mat4): Mat4

- ### En

  Get a world transform matrix with only rotation and scale

  ### Zh

  获取只包含旋转和缩放的世界变换矩阵

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new matrix will be generated and return

  #### Parameters

  - ##### `Optional` out: Mat4

    Set the result to out matrix

  #### Returns Mat4

  Inherited from LayerPopUp.getWorldRS

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24993

### getWorldRT

- getWorldRT(out?: Mat4): Mat4

- ### En

  Get a world transform matrix with only rotation and translation

  ### Zh

  获取只包含旋转和位移的世界变换矩阵

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new matrix will be generated and return

  #### Parameters

  - ##### `Optional` out: Mat4

    Set the result to out matrix

  #### Returns Mat4

  Inherited from LayerPopUp.getWorldRT

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25000

### getWorldRotation

- getWorldRotation(out?: Quat): Quat

- ### En

  Get rotation as quaternion in world coordinate system, please try to pass `out` quaternion and reuse it to avoid garbage.

  ### Zh

  获取世界坐标系下的旋转，注意，尽可能传递复用的 Quat 以避免产生垃圾。

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new quaternion will be generated and return

  #### Parameters

  - ##### `Optional` out: Quat

    Set the result to out quaternion

  #### Returns Quat

  Inherited from LayerPopUp.getWorldRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24958

### getWorldScale

- getWorldScale(out?: Vec3): Vec3

- ### En

  Get scale in world coordinate system, please try to pass `out` vector and reuse it to avoid garbage.

  ### Zh

  获取世界缩放，注意，尽可能传递复用的 Vec3 以避免产生垃圾。

  ### Returns

  If `out` given, the return value equals to `out`, otherwise a new vector will be generated and return

  #### Parameters

  - ##### `Optional` out: Vec3

    Set the result to out vector

  #### Returns Vec3

  Inherited from LayerPopUp.getWorldScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24979

### has

- has(prefabPath: string): boolean

- 判断当前层是否包含 uuid或预制件路径对应的Node节点

  #### Parameters

  - ##### prefabPath: string

    预制件路径或者UUID

  #### Returns boolean

  Inherited from LayerPopUp.has

  - Defined in assets/core/gui/layer/LayerUI.ts:173

### hasEventListener

- hasEventListener(type: string, callback?: Function, target?: unknown): any

- ### En

  Checks whether the EventTarget object has any callback registered for a specific type of event.

  ### Zh

  检查事件目标对象是否有为特定类型的事件注册的回调。

  ### Returns

  True if a callback of the specified type is registered; false otherwise.

  #### Parameters

  - ##### type: string

    The type of event.

  - ##### `Optional` callback: Function

    The callback function of the event listener, if absent all event listeners for the given type will be removed

  - ##### `Optional` target: unknown

    The callback callee of the event listener

  #### Returns any

  Inherited from LayerPopUp.hasEventListener

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24590

### insertChild

- insertChild(child: Node, siblingIndex: number): void

- ### En

  Inserts a child to the node at a specified index.

  ### Zh

  插入子节点到指定位置

  ### Example

      node.insertChild(child, 2);

  #### Parameters

  - ##### child: Node

    the child node to be inserted

  - ##### siblingIndex: number

    the sibling index to place the child in

  #### Returns void

  Inherited from LayerPopUp.insertChild

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24290

### invalidateChildren

- invalidateChildren(dirtyBit: TransformBit): void

- ### En

  Invalidate the world transform information for this node and all its children recursively

  ### Zh

  递归标记节点世界变换为 dirty

  #### Parameters

  - ##### dirtyBit: TransformBit

    The dirty bits to setup to children, can be composed with multiple dirty bits

  #### Returns void

  Inherited from LayerPopUp.invalidateChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24815

### inverseTransformPoint

- inverseTransformPoint(out: Vec3, p: Vec3): Vec3

- ### En

  Inversely transform a point from world coordinate system to local coordinate system.

  ### Zh

  逆向变换一个空间点，一般用于将世界坐标转换到本地坐标系中。

  #### Parameters

  - ##### out: Vec3

    The result point in local coordinate system will be stored in this vector

  - ##### p: Vec3

    A position in world coordinate system

  #### Returns Vec3

  Inherited from LayerPopUp.inverseTransformPoint

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24907

### isChildOf

- isChildOf(parent: null | Scene | LayerDialog ): boolean

- ### En

  Is this node a child of the given node?

  ### Zh

  是否是指定节点的子节点？

  ### Returns

  True if this node is a child, deep child or identical to the given node.

  #### Parameters

  - ##### parent: null | Scene | LayerDialog

  #### Returns boolean

  Inherited from LayerPopUp.isChildOf

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24348

### isTransformDirty

- isTransformDirty(): boolean

- ### En

  Does the world transform information of this node need to be updated?

  ### Zh

  这个节点的空间变换信息是否需要更新？

  #### Returns boolean

  Inherited from LayerPopUp.isTransformDirty

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25013

### `Protected` load

- load(vp: ViewParams, bundle?: string): void

- 加载界面资源

  #### Parameters

  - ##### vp: ViewParams

    显示参数

  - ##### `Optional` bundle: string

    远程资源包名，如果为空就是默认本地资源包

  #### Returns void

  Inherited from LayerPopUp.load

  - Defined in assets/core/gui/layer/LayerUI.ts:62

### lookAt

- lookAt(pos: Readonly<Vec3>, up?: Readonly<Vec3>): void

- ### En

  Set the orientation of the node to face the target position, the node is facing minus z direction by default

  ### Zh

  设置当前节点旋转为面向目标位置，默认前方为 -z 方向

  #### Parameters

  - ##### pos: Readonly<Vec3>

    Target position

  - ##### `Optional` up: Readonly<Vec3>

    Up direction

  #### Returns void

  Inherited from LayerPopUp.lookAt

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24808

### `Private` next

- next(): void

- #### Returns void

  - Defined in assets/core/gui/layer/LayerDialog.ts:75

### off

- off(type: string, callback?: Function, target?: unknown, useCapture?: any): void

- ### En

  Removes the callback previously registered with the same type, callback, target and or useCapture. This method is merely an alias to removeEventListener.

  ### Zh

  删除之前与同类型，回调，目标或 useCapture 注册的回调。

  ### Example

      this.node.off(NodeEventType.TOUCH_START, this.memberFunction, this);
      node.off(NodeEventType.TOUCH_START, callback, this.node);

  #### Parameters

  - ##### type: string

    A string representing the event type being removed.

  - ##### `Optional` callback: Function

    The callback to remove.

  - ##### `Optional` target: unknown

    The target (this object) to invoke the callback, if it's not given, only callback without target will be removed

  - ##### `Optional` useCapture: any

    When set to true, the listener will be triggered at capturing phase which is ahead of the final target emit, otherwise it will be triggered during bubbling phase.

  #### Returns void

  Inherited from LayerPopUp.off

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24542

### on

- on(type: string, callback: Function, target?: unknown, useCapture?: any): void

- ### En

  Register a callback of a specific event type on Node. Use this method to register touch or mouse event permit propagation based on scene graph, These kinds of event are triggered with dispatchEvent, the dispatch process has three steps:

  1. Capturing phase: dispatch in capture targets, e.g. parents in node tree, from root to the real target
  2. At target phase: dispatch to the listeners of the real target
  3. Bubbling phase: dispatch in bubble targets, e.g. parents in node tree, from the real target to root In any moment of the dispatching process, it can be stopped via `event.stopPropagation()` or `event.stopPropagationImmediate()`. You can also register custom event and use `emit` to trigger custom event on Node. For such events, there won't be capturing and bubbling phase, your event will be dispatched directly to its listeners registered on the same node. You can also pass event callback parameters with `emit` by passing parameters after `type`.

  ### Zh

  在节点上注册指定类型的回调函数，也可以设置 target 用于绑定响应函数的 this 对象。 鼠标或触摸事件会被系统调用 dispatchEvent 方法触发，触发的过程包含三个阶段：

  1. 捕获阶段：派发事件给捕获目标，比如，节点树中注册了捕获阶段的父节点，从根节点开始派发直到目标节点。
  2. 目标阶段：派发给目标节点的监听器。
  3. 冒泡阶段：派发事件给冒泡目标，比如，节点树中注册了冒泡阶段的父节点，从目标节点开始派发直到根节点。 同时您可以将事件派发到父节点或者通过调用 stopPropagation 拦截它。 你也可以注册自定义事件到节点上，并通过 emit 方法触发此类事件，对于这类事件，不会发生捕获冒泡阶段，只会直接派发给注册在该节点上的监听器 你可以通过在 emit 方法调用时在 type 之后传递额外的参数作为事件回调的参数列表

  ### Returns

  - Just returns the incoming callback so you can save the anonymous function easier.

  ### Example

      this.node.on(NodeEventType.TOUCH_START, this.memberFunction, this);  // if "this" is component and the "memberFunction" declared in CCClass.
      node.on(NodeEventType.TOUCH_START, callback, this);
      node.on(NodeEventType.TOUCH_MOVE, callback, this);
      node.on(NodeEventType.TOUCH_END, callback, this);

  #### Parameters

  - ##### type: string

    A string representing the event type to listen for.
    See Node.EventType.POSITION_CHANGED for all builtin events.

  - ##### callback: Function

    The callback that will be invoked when the event is dispatched. The callback is ignored if it is a duplicate (the callbacks are unique).

  - ##### `Optional` target: unknown

    The target (this object) to invoke the callback, can be null

  - ##### `Optional` useCapture: any

    When set to true, the listener will be triggered at capturing phase which is ahead of the final target emit, otherwise it will be triggered during bubbling phase.

  #### Returns void

  Inherited from LayerPopUp.on

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24525

### `Protected` onHide

- onHide(vp: ViewParams ): void

- #### Parameters

  - ##### vp: ViewParams

  #### Returns void

  Inherited from LayerPopUp.onHide

  - Defined in assets/core/gui/layer/LayerPopup.ts:43

### once

- once(type: string, callback: Function, target?: unknown, useCapture?: any): void

- ### En

  Register an callback of a specific event type on the Node, the callback will remove itself after the first time it is triggered.

  ### Zh

  注册节点的特定事件类型回调，回调会在第一时间被触发后删除自身。

  #### Parameters

  - ##### type: string

    A string representing the event type to listen for.

  - ##### callback: Function

    The callback that will be invoked when the event is dispatched. The callback is ignored if it is a duplicate (the callbacks are unique).

  - ##### `Optional` target: unknown

    The target (this object) to invoke the callback, can be null

  - ##### `Optional` useCapture: any

  #### Returns void

  Inherited from LayerPopUp.once

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24555

### `Protected` openVacancyRemove

- openVacancyRemove(config: UIConfig ): void

- 启动触摸非窗口区域关闭

  #### Parameters

  - ##### config: UIConfig

  #### Returns void

  Inherited from LayerPopUp.openVacancyRemove

  - Defined in assets/core/gui/layer/LayerPopup.ts:76

### pauseSystemEvents

- pauseSystemEvents(recursive: boolean): void

- ### En

  Pause all system events which is dispatched by SystemEvent. If recursive is set to true, then this API will pause the node system events for the node and all nodes in its sub node tree.

  ### Zh

  暂停所有 SystemEvent 派发的系统事件。 如果传递 recursive 为 true，那么这个 API 将暂停本节点和它的子树上所有节点的节点系统事件。

  #### Parameters

  - ##### recursive: boolean

    Whether pause system events recursively for the child node tree

  #### Returns void

  Inherited from LayerPopUp.pauseSystemEvents

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25024

### remove

- remove(prefabPath: string, isDestroy?: boolean): void

- 根据预制件路径删除，预制件如在队列中也会被删除，如果该预制件存在多个也会一起删除

  #### Parameters

  - ##### prefabPath: string

    预制路径

  - ##### `Optional` isDestroy: boolean

    移除后是否释放

  #### Returns void

  Inherited from LayerPopUp.remove

  - Defined in assets/core/gui/layer/LayerUI.ts:112

### removeAllChildren

- removeAllChildren(): void

- ### En

  Removes all children from the container.

  ### Zh

  移除节点所有的子节点。

  #### Returns void

  Inherited from LayerPopUp.removeAllChildren

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24342

### removeChild

- removeChild(child: Node | LayerDialog ): void

- ### En

  Removes a child from the container.

  ### Zh

  移除节点中指定的子节点。

  #### Parameters

  - ##### child: Node | LayerDialog

    The child node which will be removed.

  #### Returns void

  Inherited from LayerPopUp.removeChild

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24337

### removeComponent

- removeComponent<T>(classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): void

- ### En

  Removes a component identified by the given name or removes the component object given. You can also use component.destroy() if you already have the reference.

  ### Zh

  删除节点上的指定组件，传入参数可以是一个组件构造函数或组件名，也可以是已经获得的组件引用。 如果你已经获得组件引用，你也可以直接调用 component.destroy()

  ### Deprecated

  please destroy the component to remove it.

  ### Example

      node.removeComponent(Sprite);

  #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### classConstructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

    The class of the component to remove

  #### Returns void

  Inherited from LayerPopUp.removeComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24467
- removeComponent(classNameOrInstance: string | Component): void

- ### En

  Removes a component identified by the given name or removes the component object given. You can also use component.destroy() if you already have the reference.

  ### Zh

  删除节点上的指定组件，传入参数可以是一个组件构造函数或组件名，也可以是已经获得的组件引用。 如果你已经获得组件引用，你也可以直接调用 component.destroy()

  ### Deprecated

  please destroy the component to remove it.

  ### Example

      import { Sprite } from 'cc';
      const sprite = node.getComponent(Sprite);
      if (sprite) {
          node.removeComponent(sprite);
      }
      node.removeComponent('Sprite');

  #### Parameters

  - ##### classNameOrInstance: string | Component

    The class name of the component to remove or the component instance to be removed

  #### Returns void

  Inherited from LayerPopUp.removeComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24487

### removeFromParent

- removeFromParent(): void

- ### En

  Remove itself from its parent node. If the node have no parent, then nothing happens.

  ### Zh

  从父节点中删除该节点。 如果这个节点是一个孤立节点，那么什么都不会发生。

  #### Returns void

  Inherited from LayerPopUp.removeFromParent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24331

### resumeSystemEvents

- resumeSystemEvents(recursive: boolean): void

- ### En

  Resume all paused system events which is dispatched by SystemEvent. If recursive is set to true, then this API will resume the node system events for the node and all nodes in its sub node tree.

  ### Zh

  恢复所有 SystemEvent 派发的系统事件。 如果传递 recursive 为 true，那么这个 API 将恢复本节点和它的子树上所有节点的节点系统事件。

  #### Parameters

  - ##### recursive: boolean

    Whether resume system events recursively for the child node tree

  #### Returns void

  Inherited from LayerPopUp.resumeSystemEvents

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25036

### rotate

- rotate(rot: Quat, ns?: NodeSpace): void

- ### En

  Perform a rotation on the node

  ### Zh

  旋转节点

  #### Parameters

  - ##### rot: Quat

    The increment on rotation

  - ##### `Optional` ns: NodeSpace

    The operation coordinate space

  #### Returns void

  Inherited from LayerPopUp.rotate

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24801

### `Protected` setBlackDisable

- setBlackDisable(): void

- 设置触摸事件阻挡

  #### Returns void

  Overrides LayerPopUp.setBlackDisable

  - Defined in assets/core/gui/layer/LayerDialog.ts:67

### setParent

- setParent(value: null | Node, keepWorldTransform?: boolean): void

- ### En

  Set parent of the node.

  ### Zh

  设置该节点的父节点。

  #### Parameters

  - ##### value: null | Node

    Parent node

  - ##### `Optional` keepWorldTransform: boolean

    Whether keep node's current world transform unchanged after this operation

  #### Returns void

  Inherited from LayerPopUp.setParent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24244

### setPosition

- setPosition(position: Readonly<Vec3>): void

- ### En

  Set position in local coordinate system

  ### Zh

  设置本地坐标

  #### Parameters

  - ##### position: Readonly<Vec3>

    Target position

  #### Returns void

  Inherited from LayerPopUp.setPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24826
- setPosition(x: number, y: number, z?: number): void

- ### En

  Set position in local coordinate system

  ### Zh

  设置本地坐标

  #### Parameters

  - ##### x: number

    X axis position

  - ##### y: number

    Y axis position

  - ##### `Optional` z: number

    Z axis position

  #### Returns void

  Inherited from LayerPopUp.setPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24834

### setRTS

- setRTS(rot?: Vec3 | Quat, pos?: Vec3, scale?: Vec3): void

- ### En

  Set local transformation with rotation, position and scale separately.

  ### Zh

  一次性设置所有局部变换（平移、旋转、缩放）信息

  #### Parameters

  - ##### `Optional` rot: Vec3 | Quat

    The rotation

  - ##### `Optional` pos: Vec3

    The position

  - ##### `Optional` scale: Vec3

    The scale

  #### Returns void

  Inherited from LayerPopUp.setRTS

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25008

### setRotation

- setRotation(rotation: Readonly<Quat>): void

- ### En

  Set rotation in local coordinate system with a quaternion representing the rotation. Please make sure the rotation is normalized.

  ### Zh

  用四元数设置本地旋转, 请确保设置的四元数已归一化。

  #### Parameters

  - ##### rotation: Readonly<Quat>

    Rotation in quaternion

  #### Returns void

  Inherited from LayerPopUp.setRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24848
- setRotation(x: number, y: number, z: number, w: number): void

- ### En

  Set rotation in local coordinate system with a quaternion representing the rotation. Please make sure the rotation is normalized.

  ### Zh

  用四元数设置本地旋转, 请确保设置的四元数已归一化。

  #### Parameters

  - ##### x: number

    X value in quaternion

  - ##### y: number

    Y value in quaternion

  - ##### z: number

    Z value in quaternion

  - ##### w: number

    W value in quaternion

  #### Returns void

  Inherited from LayerPopUp.setRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24858

### setRotationFromEuler

- setRotationFromEuler(rotation: Vec3): void

- ### En

  Set rotation in local coordinate system with a vector representing euler angles

  ### Zh

  用欧拉角设置本地旋转

  #### Parameters

  - ##### rotation: Vec3

    Rotation in vector

  #### Returns void

  Inherited from LayerPopUp.setRotationFromEuler

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24864
- setRotationFromEuler(x: number, y: number, zOpt?: number): void

- ### En

  Set rotation in local coordinate system with euler angles

  ### Zh

  用欧拉角设置本地旋转

  #### Parameters

  - ##### x: number

    X axis rotation

  - ##### y: number

    Y axis rotation

  - ##### `Optional` zOpt: number

  #### Returns void

  Inherited from LayerPopUp.setRotationFromEuler

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24872

### setScale

- setScale(scale: Readonly<Vec3>): void

- ### En

  Set scale in local coordinate system

  ### Zh

  设置本地缩放

  #### Parameters

  - ##### scale: Readonly<Vec3>

    Target scale

  #### Returns void

  Inherited from LayerPopUp.setScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24885
- setScale(x: number, y: number, z?: number): void

- ### En

  Set scale in local coordinate system

  ### Zh

  设置本地缩放

  #### Parameters

  - ##### x: number

    X axis scale

  - ##### y: number

    Y axis scale

  - ##### `Optional` z: number

    Z axis scale

  #### Returns void

  Inherited from LayerPopUp.setScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24893

### setSiblingIndex

- setSiblingIndex(index: number): void

- ### En

  Set the sibling index of the current node in its parent's children array.

  ### Zh

  设置当前节点在父节点的 children 数组中的位置。

  #### Parameters

  - ##### index: number

  #### Returns void

  Inherited from LayerPopUp.setSiblingIndex

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24300

### setWorldPosition

- setWorldPosition(position: Vec3): void

- ### En

  Set position in world coordinate system

  ### Zh

  设置世界坐标

  #### Parameters

  - ##### position: Vec3

    Target position

  #### Returns void

  Inherited from LayerPopUp.setWorldPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24913
- setWorldPosition(x: number, y: number, z: number): void

- ### En

  Set position in world coordinate system

  ### Zh

  设置世界坐标

  #### Parameters

  - ##### x: number

    X axis position

  - ##### y: number

    Y axis position

  - ##### z: number

    Z axis position

  #### Returns void

  Inherited from LayerPopUp.setWorldPosition

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24921

### setWorldRotation

- setWorldRotation(rotation: Quat): void

- ### En

  Set rotation in world coordinate system with a quaternion representing the rotation

  ### Zh

  用四元数设置世界坐标系下的旋转

  #### Parameters

  - ##### rotation: Quat

    Rotation in quaternion

  #### Returns void

  Inherited from LayerPopUp.setWorldRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24934
- setWorldRotation(x: number, y: number, z: number, w: number): void

- ### En

  Set rotation in world coordinate system with a quaternion representing the rotation

  ### Zh

  用四元数设置世界坐标系下的旋转

  #### Parameters

  - ##### x: number

    X value in quaternion

  - ##### y: number

    Y value in quaternion

  - ##### z: number

    Z value in quaternion

  - ##### w: number

    W value in quaternion

  #### Returns void

  Inherited from LayerPopUp.setWorldRotation

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24943

### setWorldRotationFromEuler

- setWorldRotationFromEuler(x: number, y: number, z: number): void

- ### En

  Set rotation in world coordinate system with euler angles

  ### Zh

  用欧拉角设置世界坐标系下的旋转

  #### Parameters

  - ##### x: number

    X axis rotation

  - ##### y: number

    Y axis rotation

  - ##### z: number

    Z axis rotation

  #### Returns void

  Inherited from LayerPopUp.setWorldRotationFromEuler

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24951

### setWorldScale

- setWorldScale(scale: Vec3): void

- ### En

  Set scale in world coordinate system

  ### Zh

  设置世界坐标系下的缩放

  #### Parameters

  - ##### scale: Vec3

    Target scale

  #### Returns void

  Inherited from LayerPopUp.setWorldScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24964
- setWorldScale(x: number, y: number, z: number): void

- ### En

  Set scale in world coordinate system

  ### Zh

  设置世界坐标系下的缩放

  #### Parameters

  - ##### x: number

    X axis scale

  - ##### y: number

    Y axis scale

  - ##### z: number

    Z axis scale

  #### Returns void

  Inherited from LayerPopUp.setWorldScale

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24972

### `Private` show

- show(config: UIConfig, params?: any, callbacks?: UICallbacks ): string

- 显示模式弹窗

  #### Parameters

  - ##### config: UIConfig

  - ##### `Optional` params: any

  - ##### `Optional` callbacks: UICallbacks

  #### Returns string

  - Defined in assets/core/gui/layer/LayerDialog.ts:43

### `Protected` showUi

- showUi(vp: ViewParams ): void

- 创建界面节点

  #### Parameters

  - ##### vp: ViewParams

    视图参数

  #### Returns void

  Inherited from LayerPopUp.showUi

  - Defined in assets/core/gui/layer/LayerPopup.ts:33

### targetOff

- targetOff(target: unknown): void

- ### En

  Removes all callbacks previously registered with the same target.

  ### Zh

  移除目标上的所有注册事件。

  #### Parameters

  - ##### target: unknown

    The target to be searched for all related callbacks

  #### Returns void

  Inherited from LayerPopUp.targetOff

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24596

### translate

- translate(trans: Vec3, ns?: NodeSpace): void

- ### En

  Perform a translation on the node

  ### Zh

  移动节点

  #### Parameters

  - ##### trans: Vec3

    The increment on position

  - ##### `Optional` ns: NodeSpace

    The operation coordinate space

  #### Returns void

  Inherited from LayerPopUp.translate

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24794

### updateWorldTransform

- updateWorldTransform(): void

- ### En

  Update the world transform information if outdated

  ### Zh

  更新节点的世界变换信息

  #### Returns void

  Inherited from LayerPopUp.updateWorldTransform

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24820

### walk

- walk(preFunc: ((target: LayerDialog ) => void), postFunc?: ((target: LayerDialog ) => void)): void

- ### En

  Walk though the sub children tree of the current node. Each node, including the current node, in the sub tree will be visited two times, before all children and after all children. This function call is not recursive, it's based on stack. Please don't walk any other node inside the walk process.

  ### Zh

  遍历该节点的子树里的所有节点并按规则执行回调函数。 对子树中的所有节点，包含当前节点，会执行两次回调，preFunc 会在访问它的子节点之前调用，postFunc 会在访问所有子节点之后调用。 这个函数的实现不是基于递归的，而是基于栈展开递归的方式。 请不要在 walk 过程中对任何其他的节点嵌套执行 walk。

  ### Example

      node.walk(function (target) {
          console.log('Walked through node ' + target.name + ' for the first time');
      }, function (target) {
          console.log('Walked through node ' + target.name + ' after walked all children in its sub tree');
      });

  #### Parameters

  - ##### preFunc: ((target: LayerDialog ) => void)

    The callback to process node when reach the node for the first time

    - - (target: LayerDialog ): void

      - #### Parameters

        - ##### target: LayerDialog

        #### Returns void

  - ##### `Optional` postFunc: ((target: LayerDialog ) => void)

    The callback to process node when re-visit the node after walked all children in its sub tree

    - - (target: LayerDialog ): void

      - #### Parameters

        - ##### target: LayerDialog

        #### Returns void

  Inherited from LayerPopUp.walk

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24322

### `Static` _deferredDestroy

- _deferredDestroy(): void

- #### Returns void

  Inherited from LayerPopUp._deferredDestroy

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:20873

### `Static` `Protected` _findChildComponent

- _findChildComponent<T>(children: Node[], constructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): null | T

- #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### children: Node[]

  - ##### constructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

  #### Returns null | T

  Inherited from LayerPopUp._findChildComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24186

### `Static` `Protected` _findChildComponents

- _findChildComponents(children: Node[], constructor: any, components: any): void

- #### Parameters

  - ##### children: Node[]

  - ##### constructor: any

  - ##### components: any

  #### Returns void

  Inherited from LayerPopUp._findChildComponents

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24187

### `Static` `Protected` _findComponent

- _findComponent<T>(node: Node, constructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>): null | T

- #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### node: Node

  - ##### constructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

  #### Returns null | T

  Inherited from LayerPopUp._findComponent

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24184

### `Static` `Protected` _findComponents

- _findComponents<T>(node: Node, constructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>, components: Component[]): void

- #### Type Parameters

  - #### T extends Component<T>

  #### Parameters

  - ##### node: Node

  - ##### constructor: __types_globals__Constructor<T> | __types_globals__AbstractedConstructor<T>

  - ##### components: Component[]

  #### Returns void

  Inherited from LayerPopUp._findComponents

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24185

### `Static` `Protected` _setScene

- _setScene(node: Node): void
- `Internal`

  Call `_updateScene` of specified node.

  #### Parameters

  - ##### node: Node

    The node.

  #### Returns void

  Inherited from LayerPopUp._setScene

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24183

### `Static` clearNodeArray

- clearNodeArray(): void

- ### En

  clear node array

  ### Zh

  清除节点数组

  #### Returns void

  Inherited from LayerPopUp.clearNodeArray

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25050

### `Static` isNode

- isNode(obj: unknown): obj is Node

- ### En

  Determine whether the given object is a normal Node. Will return false if Scene given.

  ### Zh

  指定对象是否是普通的节点？如果传入 Scene 会返回 false。

  #### Parameters

  - ##### obj: unknown

  #### Returns obj is Node

  Inherited from LayerPopUp.isNode

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:24677

### `Static` resetHasChangedFlags

- resetHasChangedFlags(): void

- ### En

  clear all node dirty state.

  ### Zh

  清除所有节点的脏标记。

  #### Returns void

  Inherited from LayerPopUp.resetHasChangedFlags

  - Defined in ../../../../cocos_editor/Creator/3.8.3/resources/resources/3d/engine/bin/.declarations/cc.d.ts:25043

Generated using TypeDoc